# SPDX-License-Identifier: GPL-2.0
%YAML 1.2
---
$id: http://devicetree.org/schemas/display/brcm,bcm2835-hvs.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Broadcom VC4 (VideoCore4) Hardware Video Scaler

maintainers:
  - Eric Anholt <eric@anholt.net>

properties:
  compatible:
    enum:
      - brcm,bcm2711-hvs
      - brcm,bcm2712-hvs
      - brcm,bcm2835-hvs

  reg:
    maxItems: 1

  interrupts:
    minItems: 1
    maxItems: 3

  interrupt-names:
    minItems: 1
    maxItems: 3

  clocks:
    minItems: 1
    maxItems: 2

  clock-names:
    minItems: 1
    maxItems: 2

required:
  - compatible
  - reg
  - interrupts

additionalProperties: false

allOf:
  - if:
      properties:
        compatible:
          contains:
            const: brcm,bcm2711-hvs

    then:
      properties:
        clocks:
          items:
            - description: Core Clock
        interrupts:
          maxItems: 1
        clock-names: false
        interrupt-names: false

      required:
        - clocks

  - if:
      properties:
        compatible:
          contains:
            const: brcm,bcm2712-hvs

    then:
      properties:
        clocks:
          minItems: 2
          maxItems: 2
        clock-names:
          items:
            - const: core
            - const: disp
        interrupts:
          items:
            - description: Channel 0 End of frame
            - description: Channel 1 End of frame
            - description: Channel 2 End of frame
        interrupt-names:
          items:
            - const: ch0-eof
            - const: ch1-eof
            - const: ch2-eof
      required:
        - clocks
        - clock-names
        - interrupt-names

  - if:
      properties:
        compatible:
          contains:
            const: brcm,bcm2835-hvs

    then:
      properties:
        interrupts:
          maxItems: 1
        clock-names: false
        interrupt-names: false

examples:
  - |
    hvs@7e400000 {
        compatible = "brcm,bcm2835-hvs";
        reg = <0x7e400000 0x6000>;
        interrupts = <2 1>;
    };

...
